VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "MDBAnalyzer"
   ClientHeight    =   1200
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1200
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAnalyze 
      Caption         =   "Analyze"
      Default         =   -1  'True
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   3615
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Function TypeName(ByVal type_number As Integer) As String
    Select Case type_number
        Case DataTypeEnum.dbBigInt
            TypeName = "BigInt"
        Case DataTypeEnum.dbBinary
            TypeName = "Binary"
        Case DataTypeEnum.dbBoolean
            TypeName = "Boolean"
        Case DataTypeEnum.dbByte
            TypeName = "Byte"
        Case DataTypeEnum.dbChar
            TypeName = "Char"
        Case DataTypeEnum.dbCurrency
            TypeName = "Currency"
        Case DataTypeEnum.dbDate
            TypeName = "Date"
        Case DataTypeEnum.dbDecimal
            TypeName = "Decimal"
        Case DataTypeEnum.dbDouble
            TypeName = "Double"
        Case DataTypeEnum.dbFloat
            TypeName = "Float"
        Case DataTypeEnum.dbGUID
            TypeName = "GUID"
        Case DataTypeEnum.dbInteger
            TypeName = "Integer"
        Case DataTypeEnum.dbLong
            TypeName = "Long"
        Case DataTypeEnum.dbLongBinary
            TypeName = "LongBinary"
        Case DataTypeEnum.dbMemo
            TypeName = "Memo"
        Case DataTypeEnum.dbNumeric
            TypeName = "Numeric"
        Case DataTypeEnum.dbSingle
            TypeName = "Single"
        Case DataTypeEnum.dbText
            TypeName = "Text"
        Case DataTypeEnum.dbTime
            TypeName = "Time"
        Case DataTypeEnum.dbTimeStamp
            TypeName = "TimeStamp"
        Case DataTypeEnum.dbVarBinary
            TypeName = "VarBinary"
    End Select
End Function

Private Sub cmdAnalyze_Click()
Dim excel_app As Excel.Application
Dim excel_workbook As Excel.Workbook
Dim excel_worksheet As Excel.Worksheet
Dim max_table_row As Integer
Dim row_num As Integer
Dim col_num As Integer
Dim db As DAO.Database
Dim field_properties() As String
Dim index_properties() As String
Dim table_def As DAO.TableDef
Dim field_def As DAO.Field
Dim index_def As DAO.Index
Dim relation_def As DAO.Relation
Dim txt As String
Dim i As Integer

    Screen.MousePointer = vbHourglass
    DoEvents

    field_properties = Split("Name,Type,Size,AllowZeroLength,DefaultValue,Required,Description", ",")
    index_properties = Split("Name,Primary,Required,Unique,Foreign", ",")

    ' Open Excel and create a new workbook.
    Set excel_app = New Excel.Application
    Set excel_workbook = excel_app.Workbooks.Add()
    Set excel_worksheet = excel_workbook.Sheets(1)

    ' Examine the tables.
    row_num = 1

    ' Section heading.
    excel_worksheet.Cells(row_num, 1) = "Tables"
    With excel_worksheet.Range("A" & row_num).Font
        .Size = 25
        .Bold = True
        .Color = vbRed
    End With
    row_num = row_num + 1

    Set db = DBEngine(0).OpenDatabase(txtDatabase.Text, ReadOnly:=False)
    For Each table_def In db.TableDefs
        Me.Caption = "MDBAnalyzer: " & table_def.Name
        DoEvents

        ' Skip the system tables.
        If LCase$(Left$(table_def.Name, 4)) <> "msys" Then
            ' Display this table.
            excel_worksheet.Cells(row_num, 1) = table_def.Name
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 20
                .Bold = True
                .Color = vbBlue
            End With

            row_num = row_num + 1
            On Error Resume Next
            txt = table_def.Properties("Description")
            If Err.Number <> 0 Then txt = "?????"
            excel_worksheet.Cells(row_num, 1) = txt
            On Error GoTo 0
            row_num = row_num + 1

            ' Display field data.
            excel_worksheet.Cells(row_num, 1) = "Fields"
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 16
                .Bold = True
            End With
            row_num = row_num + 1

            ' Headers.
            For col_num = LBound(field_properties) To UBound(field_properties)
                excel_worksheet.Cells(row_num, col_num + 1) = field_properties(col_num)
            Next col_num
            With excel_worksheet.Range("A" & row_num, "Z" & row_num).Font
                .Bold = True
            End With
            row_num = row_num + 1

            ' Fields.
            For Each field_def In table_def.Fields
                For col_num = LBound(field_properties) To UBound(field_properties)
                    If field_properties(col_num) = "Type" Then
                        excel_worksheet.Cells(row_num, col_num + 1) = _
                            TypeName(field_def.Type)
                    Else
                        On Error Resume Next
                        txt = field_def.Properties(field_properties(col_num))
                        If Err.Number <> 0 Then txt = "?????"
                        excel_worksheet.Cells(row_num, col_num + 1) = txt
                        On Error GoTo 0
                    End If
                Next col_num
                row_num = row_num + 1
            Next field_def

            ' Display index information.
            excel_worksheet.Cells(row_num, 1) = "Indexes"
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 16
                .Bold = True
            End With
            row_num = row_num + 1

            ' Headers.
            For col_num = LBound(index_properties) To UBound(index_properties)
                excel_worksheet.Cells(row_num, col_num + 1) = index_properties(col_num)
            Next col_num
            excel_worksheet.Cells(row_num, UBound(index_properties) + 2) = "Fields"
            With excel_worksheet.Range("A" & row_num, "Z" & row_num).Font
                .Bold = True
            End With
            row_num = row_num + 1

            ' Indexes.
            For Each index_def In table_def.Indexes
                For col_num = LBound(index_properties) To UBound(index_properties)
                    On Error Resume Next
                    txt = index_def.Properties(index_properties(col_num))
                    If Err.Number <> 0 Then txt = "?????"
                    excel_worksheet.Cells(row_num, col_num + 1) = txt
                    On Error GoTo 0
                Next col_num

                ' List the index's fields.
                col_num = UBound(index_properties) + 2
                If index_def.Fields.Count > 0 Then
                    For Each field_def In index_def.Fields
                        excel_worksheet.Cells(row_num, col_num) = field_def.Name
                        row_num = row_num + 1
                    Next field_def
                Else
                    row_num = row_num + 1
                End If
            Next index_def

            row_num = row_num + 1
        End If ' End if not MSys table.
    Next table_def

    ' Display database relations.
    ' Section heading.
    excel_worksheet.Cells(row_num, 1) = "Relations"
    With excel_worksheet.Range("A" & row_num).Font
        .Size = 25
        .Bold = True
        .Color = vbRed
    End With
    row_num = row_num + 1

    ' Headers.
    excel_worksheet.Cells(row_num, 1) = "Name"
    excel_worksheet.Cells(row_num, 2) = "Source Table"
    excel_worksheet.Cells(row_num, 3) = "Foreign Table"
    excel_worksheet.Range("A" & row_num, "C" & row_num).Font.Bold = True
    row_num = row_num + 1

    ' Display the relations.
    For Each relation_def In db.Relations
        excel_worksheet.Cells(row_num, 1) = relation_def.Name
        For i = 0 To relation_def.Fields.Count - 1
            Set field_def = relation_def.Fields(i)
            excel_worksheet.Cells(row_num, 2) = _
                relation_def.Table & "." & _
                field_def.Name
            excel_worksheet.Cells(row_num, 3) = _
                relation_def.ForeignTable & "." & _
                field_def.ForeignName
            row_num = row_num + 1
        Next i
    Next relation_def

    excel_worksheet.Range("A1", "Z" & row_num).Columns.ColumnWidth = 20

    ' Display the Excel application.
    ' Comment this out, save the file, and close the application
    ' if you want to do it all silently.
    excel_app.Visible = True

    Me.Caption = "Done"
    Screen.MousePointer = vbDefault
    MsgBox "Done"
End Sub
Private Sub Form_Load()
Dim txt As String

    txt = App.Path
    If Right$(txt, 1) <> "\" Then txt = txt & "\"
    txtDatabase.Text = txt & "TestData.mdb"
End Sub


Private Sub Form_Resize()
Const GAP As Single = 120

Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - GAP - txtDatabase.Left
    If wid < GAP Then wid = GAP
    txtDatabase.Width = wid

    cmdAnalyze.Left = (ScaleWidth - cmdAnalyze.Width) / 2
End Sub


